;***************************************************************************
rocketEmitterBehaviour 
                    ldb      X_POS+u_offset1,u 
                    MY_MOVE_TO_D_START  
; change coordinates, 16 bit
; ypos
                    lda      Y_VEL+u_offset1,u 
                    ldx      Y_POS+u_offset1,u 
                    leax     a,x 
                    leax     a,x 
                    stx      Y_POS+u_offset1,u 
; xpos
                    lda      X_VEL+u_offset1,u 
                    ldx      X_POS+u_offset1,u 
                    leax     a,x 
                    stx      X_POS+u_offset1,u 

                    dec      AGE+u_offset1,u 
                    beq      explodeRocket
                    ldu      NEXT_OBJECT+u_offset1,u      ; preload next user stack 
                    LDB      #10                          ; really BRIGHT 
                    MY_MOVE_TO_A_END  
                    clra     
                    dec      <VIA_shift_reg               ;Store in VIA shift register 
LF2CC_2_rl 
                    DECB                                  ;Delay leaving beam in place 
                    bpl      LF2CC_2_rl 
                    sta      <VIA_shift_reg               ;Blank beam in VIA shift register 
                    _ZERO_VECTOR_BEAM  
                    pulu     d,pc 

; ...............................................
explodeRocket
                    pshs     u 
                    leax     ,u 
                    lda      #30
                    sta      tmp1 
contEmit_er 
                    jsr      newObject 
                    cmpu     #PLIST_COMPARE_ADDRESS 
                    bls      noNewParticle3_er
                    ldd      #velocityParticleParticleBehaviour 
                    std      BEHAVIOUR, u 
; 16 bit position of velocityParticle
                    clrb     
                    lda      Y_POS+u_offset1,x 
                    std      Y_POS, u 
                    lda      X_POS+u_offset1,x 
                    std      X_POS, u 
                    RANDOM_A_alt  
                    anda     #%01111111                   ; always positive Y velocity 
                    sta      Y_VEL, u 
                    RANDOM_A_alt  
                    sta      X_VEL, u 
                    RANDOM_A_alt  
                    anda     #%00111111                   ; slightly different age 
                    nega     
                    adda     #150 
                    sta      AGE,U 
                    dec      tmp1 
                    lbpl     contEmit_er 
noNewParticle3_er 
                    puls     u 
                    jmp     destroyPObject 

;
;***************************************************************************
;
GRAVITY_Y           =        2 
GRAVITY_X           =        1 
velocityParticleParticleBehaviour 
; position to 
                    ldb      X_POS+u_offset1,u 
                    MY_MOVE_TO_D_START  
; update 
; x velocity towards 0
                    lda      X_VEL+u_offset1,u 
                    beq      xStays 
                    bmi      negativeXVel 
                    suba     #GRAVITY_X 
                    bmi      xIsNull 
                    sta      X_VEL+u_offset1,u 
                    bra      xStays 

negativeXVel 
                    adda     #GRAVITY_X 
                    bpl      xIsNull 
                    sta      X_VEL+u_offset1,u 
                    bra      xStays 

xIsNull 
                    clr      X_VEL+u_offset1,u 
xStays 
; y velocity towards -128
                    lda      Y_VEL+u_offset1,u 
                    suba     #GRAVITY_Y 
                    bvc      noOverflowX 
                    lda      #$80 
noOverflowX 
                    sta      Y_VEL+u_offset1,u 
; change coordinates, 16 bit
; ypos
                    ldx      Y_POS+u_offset1,u 
                    leax     a,x 
                    stx      Y_POS+u_offset1,u 
; xpos
                    lda      X_VEL+u_offset1,u 
                    ldx      X_POS+u_offset1,u 
                    leax     a,x 
                    stx      X_POS+u_offset1,u 
                    dec      AGE+u_offset1,u 
                    lbEQ     destroyPObject 
                    ldb      AGE+u_offset1,u 
                    ldu      NEXT_OBJECT+u_offset1,u      ; preload next user stack 
                    lsrb     
                    lsrb     
                    lsrb     
                    MY_MOVE_TO_A_END  
                    clra     
                    dec      <VIA_shift_reg               ;Store in VIA shift register 
LF2CC_vp 
                    DECB                                  ;Delay leaving beam in place 
                    bpl      LF2CC_vp 
                    sta      <VIA_shift_reg               ;Blank beam in VIA shift register 
                    _ZERO_VECTOR_BEAM  
                    pulu     d,pc 
