;***************************************************************************
; DEFINE SECTION
;***************************************************************************
; load vectrex bios routine definitions
                    INCLUDE  "vars.i"                     ; vectrex function includes
;***************************************************************************
; HEADER SECTION
;***************************************************************************
; The cartridge ROM starts at address 0
                    CODE     
                    ORG      0 
; the first few bytes are mandatory, otherwise the BIOS will not load
; the ROM file, and will start MineStorm instead
                    DB       "g GCE 2018", $80 ; 'g' is copyright sign
                    DW       music1                       ; music from the rom 
                    DB       $F8, $50, $20, -$80          ; hight, width, rel y, rel x (from 0,0) 
                    DB       "PARTICLES", $80             ; some game information, ending with $80
                    DB       0                            ; end of game header 
;***************************************************************************
; CODE SECTION
;***************************************************************************
; here the cartridge program starts off
MOVE_SCALE          =        $7f 
; initialize random function
; the timer parts should be set from the title screen after the player
; presses a button to play
; 
; will be pretty random than
;
; or just set it here with fixed values
; if you always want the same random seed.
; (vide != vectrex for the timer values)
;
; each value of the 4 "random" variable change causes 
; quite different random outcomes
; so if you just want to test out different "shrooms" on screen
; keep changing e.g. "x"
                    lda      #2 
                    sta      random_x 
                    lda      #$d4 
                    sta      random_a 
                    lda      <VIA_t2_lo 
                    sta      random_b 
                    lda      <VIA_t1_cnt_lo 
                    sta      random_c 
                    RANDOM_A_alt                          ; call random once 
                    INIT_OBJECTLIST  PARTICLE1_MAX_COUNT, VelocityParticle, main 
                    clr      buttonStatus 
;...........................................................................
main: 
                    JSR      Wait_Recal                   ; Vectrex BIOS recalibration 
                    JSR      Intensity_5F                 ; Sets the intensity of the 
                    JSR      Read_Btns                    ; get button status 
                    ldb      $C811                        ; button pressed - any 
                    bitb     #1                           ; is button 1 
                    lbeq     button1NotPressedrl 
                    tst      buttonStatus                 ; only one rocket launch per button press! 
                    lbne     button1NotPressedrl2 
                    inc      buttonStatus 
; Launch a rocket on the press of a button
                    jsr      newObject 
                    cmpu     #PLIST_COMPARE_ADDRESS 
                    bls      noRLNewEmitter 
                    ldd      #rocketEmitterBehaviour 
                    std      BEHAVIOUR, u 
                    ldd      #$c000 
                    std      Y_POS, U                     ; current POS 16 bit 
                    ldd      #0 
                    std      X_POS, U                     ; current POS 
                    RANDOM_A_alt  
                    anda     #%01111111                   ; always positive Y velocity 
                    ora      #%01000000 
                    sta      Y_VEL, u 
                    RANDOM_A_alt  
                    sta      X_VEL, u 
                    RANDOM_A_alt  
                    anda     #%00111111                   ; slightly different age 
                    nega     
                    adda     #100 
                    sta      AGE,U 
noRLNewEmitter 
button1NotPressedrl 
                    clr      buttonStatus 
button1NotPressedrl2 
                    ldu      plist_objects_head 
                    pulu     d,pc                         ; (D = y,x) ; do all objects 
;...........................................................................
;***************************************************************************
                    include  "objectHandling.asm"
                    include  "ParticleDemo1.asm"
