; this file is part of Release, written by Malban in 2017
;
;***************************************************************************
_DP_TO_C8           macro                                 ; pretty for optimizing to use a makro :-) 
                    LDA      #$C8 
                    TFR      A,DP 
                    direct   $C8 
                    endm     
;***************************************************************************
_DP_TO_D0           macro                                 ; pretty for optimizing to use a makro :-) 
                    LDA      #$D0 
                    TFR      A,DP 
                    direct   $D0 
                    endm     
NEG_D               macro    
                    COMA     
                    COMB     
                    ADDD     #1 
                    endm                                  ; done 
;***************************************************************************
RESET_VECTOR_BEAM   macro    
                    LDA      #$CC 
                    STA      <VIA_cntl                    ;/BLANK low and /ZERO low 
                    lda      #$83                         ; a = $18, b = $83 disable RAMP, muxsel=false, channel 1 (integrators offsets) 
                    clr      <VIA_port_a                  ; Clear D/A output 
                    sta      <VIA_port_b                  ; set mux to channel 1, leave mux disabled 
                    dec      <VIA_port_b                  ; enable mux, reset integrator offset values 
                                                          ;nop 4 
                    LDA      #$CE 
                    STA      <VIA_cntl                    ;/BLANK high and /ZERO low 
                    inc      <VIA_port_b                  ; Disable mux 
                    endm     
;***************************************************************************
_SCALE              macro    value 
                    LDA      #\1                          ; scale for placing first point 
                    _SCALE_A  
                    endm     
;***************************************************************************
_SCALE_A            macro    
                    STA      VIA_t1_cnt_lo                ; move to time 1 lo, this means scaling 
                    endm     
;*************************************************************************** 
_ZERO_VECTOR_BEAM   macro    
                    LDB      #$CC 
                    STB      VIA_cntl                     ;/BLANK low and /ZERO low 
                    endm     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; macro D = D *2
MY_LSL_D            macro    
                    ASLB     
                    ROLA     
                    endm                                  ; done 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; macro D = D /2
MY_LSR_D            macro    
                    ASRA     
                    RORB     
                    endm                                  ; done 

;***************************************************************************
MY_MOVE_TO_D_START_NT  macro  
                    STA      <VIA_port_a 
                    LDA      #$CE                         ;Blank low, zero high? 
                    STA      <VIA_cntl                    ; 
                    CLRA     
                    STA      <VIA_port_b                  ;Enable mux 
                    STA      <VIA_shift_reg               ;Clear shift regigster 
                    INC      <VIA_port_b                  ;Disable mux 
                    STB      <VIA_port_a                  ;Store X in D/A register 
                    STA      <VIA_t1_cnt_hi               ;enable timer 
                    endm     
MY_MOVE_TO_D_START  macro    
                    STA      <VIA_port_a                  ;Store Y in D/A register 
                    LDA      #$CE                         ;Blank low, zero high? 
                    STA      <VIA_cntl                    ; 
                    CLRA     
                    STA      <VIA_port_b                  ;Enable mux ; hey dis si "break integratorzero 440" 
;                    STA      <VIA_shift_reg               ;Clear shift regigster 

 nop  ; y must be set more than xx cycles on some vectrex

                    INC      <VIA_port_b                  ;Disable mux 
                    STB      <VIA_port_a                  ;Store X in D/A register 
                    STA      <VIA_t1_cnt_hi               ;enable timer 
                    endm     
MY_MOVE_TO_D_START_NO_SHIFT  macro    
                    STA      <VIA_port_a                  ;Store Y in D/A register 
                    LDA      #$CE                         ;Blank low, zero high? 
                    STA      <VIA_cntl                    ; 
                    CLRA     
                    STA      <VIA_port_b                  ;Enable mux ; hey dis si "break integratorzero 440" 
                    INC      <VIA_port_b                  ;Disable mux 
                    STB      <VIA_port_a                  ;Store X in D/A register 
                    STA      <VIA_t1_cnt_hi               ;enable timer 
                    endm     
MY_MOVE_TO_A_END    macro    
                    local    LF33D 
                    LDA      #$40                         ; 
LF33D\?:            BITA     <VIA_int_flags               ; 
                    BEQ      LF33D\?                      ; 
                    endm     
MY_MOVE_TO_B_END    macro    
                    local    LF33D 
                    LDB      #$40                         ; 
LF33D\?:            BITB     <VIA_int_flags               ; 
                    BEQ      LF33D\?                      ; 
                    endm     
MY_MOVE_TO_D_END    macro    
                    local    LF33D 
                    LDB      #$40                         ; 
LF33D\?:            BITB     <VIA_int_flags               ; 
                    BEQ      LF33D\?                      ; 
                    endm     
MY_MOVE_TO_D        macro    
; optimzed, tweaked not perfect... 'MOVE TO D' makro
                    MY_MOVE_TO_D_START  
                    MY_MOVE_TO_B_END  
                    endm     
MY_MOVE_TO_D_NT     macro    
; optimzed, tweaked not perfect... 'MOVE TO D' makro
                    MY_MOVE_TO_D_START_NT  
                    MY_MOVE_TO_B_END  
                    endm     
;***************************************************************************
_INTENSITY_A_8      macro    
                    STA      <VIA_port_a                  ;Store intensity in D/A 
                    LDD      #$8584                       ;mux disabled channel 2 
                    STA      <VIA_port_b                  ; 
                    STB      <VIA_port_b                  ;mux enabled channel 2 
                    STA      <VIA_port_b                  ;turn off mux 
                    endm     
_INTENSITY_A        macro    
                    STA      <VIA_port_a                  ;Store intensity in D/A 
                    LDD      #$0504                       ;mux disabled channel 2 
                    STA      <VIA_port_b                  ; 
                    STB      <VIA_port_b                  ;mux enabled channel 2 
                    STA      <VIA_port_b                  ;turn off mux 
                    endm     
_INTENSITY_A_ONLY   macro    
                    STA      <VIA_port_a                  ;Store intensity in D/A 
                    LDa      #$05                         ;mux disabled channel 2 
                    STA      <VIA_port_b                  ; 
                    deca     
                    STa      <VIA_port_b                  ;mux enabled channel 2 
                    inca     
                    STA      <VIA_port_b                  ;turn off mux 
                    endm     
_INTENSITY_B        macro    
                    STB      <VIA_port_a                  ;Store intensity in D/A 
                    LDD      #$0504                       ;mux disabled channel 2 
                    STA      <VIA_port_b                  ; 
                    STB      <VIA_port_b                  ;mux enabled channel 2 
                    STA      <VIA_port_b                  ;turn off mux 
                    endm     

RANDOM_A_alt        macro    
                    inc      random_x 
                    lda      random_a 
                    eora     random_b 
                    eora     random_x 
                    sta      random_a 
                    adda     random_b 
                    sta      random_b 
                    lsra     
                    eora     random_a 
                    adda     random_c 
                    sta      random_c 
                    endm     


INIT_OBJECTLIST macro count, size, endJump
                    ldd      #endJump                     ; explosions jump back to here after all have been rendered 
                    std      PARTICLES_DONE_A 
; setup objects

                    lda      #count 
                    ldu      #pobject_list 
                    stu      plist_empty_head 
                    ldy      #PARTICLES_DONE 
next_list_exentry_1\? 
                    leax     size,u 
                    stx      NEXT_OBJECT,u 
                    leau     ,x 
                    deca     
                    bne      next_list_exentry_1\?
                    leau     -size,u 
                    sty      NEXT_OBJECT,u 
                    sty      plist_objects_head 
 endm
